# coding: utf-8

"""
    VeeRoute.LSS Merchandiser

    VeeRoute.LSS Merchandiser API  # noqa: E501

    The version of the OpenAPI document: 3.6.163873
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from vrt_lss_merchandiser.configuration import Configuration


class Order(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'key': 'str',
        'location': 'Location',
        'visits': 'list[EventWindow]',
        'facts': 'list[EventWindow]',
        'duration': 'float',
        'reward': 'float'
    }

    attribute_map = {
        'key': 'key',
        'location': 'location',
        'visits': 'visits',
        'facts': 'facts',
        'duration': 'duration',
        'reward': 'reward'
    }

    def __init__(self, key=None, location=None, visits=None, facts=None, duration=None, reward=1000, local_vars_configuration=None):  # noqa: E501
        """Order - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._key = None
        self._location = None
        self._visits = None
        self._facts = None
        self._duration = None
        self._reward = None
        self.discriminator = None

        self.key = key
        self.location = location
        self.visits = visits
        if facts is not None:
            self.facts = facts
        self.duration = duration
        self.reward = reward

    @property
    def key(self):
        """Gets the key of this Order.  # noqa: E501

        Unique ID.  # noqa: E501

        :return: The key of this Order.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this Order.

        Unique ID.  # noqa: E501

        :param key: The key of this Order.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and key is None:  # noqa: E501
            raise ValueError("Invalid value for `key`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                key is not None and len(key) > 1024):
            raise ValueError("Invalid value for `key`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                key is not None and len(key) < 1):
            raise ValueError("Invalid value for `key`, length must be greater than or equal to `1`")  # noqa: E501

        self._key = key

    @property
    def location(self):
        """Gets the location of this Order.  # noqa: E501


        :return: The location of this Order.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Order.


        :param location: The location of this Order.  # noqa: E501
        :type: Location
        """
        if self.local_vars_configuration.client_side_validation and location is None:  # noqa: E501
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def visits(self):
        """Gets the visits of this Order.  # noqa: E501

        Time windows list, during each time window a location should be visited.  # noqa: E501

        :return: The visits of this Order.  # noqa: E501
        :rtype: list[EventWindow]
        """
        return self._visits

    @visits.setter
    def visits(self, visits):
        """Sets the visits of this Order.

        Time windows list, during each time window a location should be visited.  # noqa: E501

        :param visits: The visits of this Order.  # noqa: E501
        :type: list[EventWindow]
        """
        if self.local_vars_configuration.client_side_validation and visits is None:  # noqa: E501
            raise ValueError("Invalid value for `visits`, must not be `None`")  # noqa: E501

        self._visits = visits

    @property
    def facts(self):
        """Gets the facts of this Order.  # noqa: E501

        List of time windows when location was visited previously.  # noqa: E501

        :return: The facts of this Order.  # noqa: E501
        :rtype: list[EventWindow]
        """
        return self._facts

    @facts.setter
    def facts(self, facts):
        """Sets the facts of this Order.

        List of time windows when location was visited previously.  # noqa: E501

        :param facts: The facts of this Order.  # noqa: E501
        :type: list[EventWindow]
        """

        self._facts = facts

    @property
    def duration(self):
        """Gets the duration of this Order.  # noqa: E501

        One visit duration in minutes.  # noqa: E501

        :return: The duration of this Order.  # noqa: E501
        :rtype: float
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """Sets the duration of this Order.

        One visit duration in minutes.  # noqa: E501

        :param duration: The duration of this Order.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and duration is None:  # noqa: E501
            raise ValueError("Invalid value for `duration`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                duration is not None and duration > 43800):  # noqa: E501
            raise ValueError("Invalid value for `duration`, must be a value less than or equal to `43800`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                duration is not None and duration < 0):  # noqa: E501
            raise ValueError("Invalid value for `duration`, must be a value greater than or equal to `0`")  # noqa: E501

        self._duration = duration

    @property
    def reward(self):
        """Gets the reward of this Order.  # noqa: E501

        The basic reward for the order completion. Penalties for not completing the order on time are deducted from the reward.   # noqa: E501

        :return: The reward of this Order.  # noqa: E501
        :rtype: float
        """
        return self._reward

    @reward.setter
    def reward(self, reward):
        """Sets the reward of this Order.

        The basic reward for the order completion. Penalties for not completing the order on time are deducted from the reward.   # noqa: E501

        :param reward: The reward of this Order.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and reward is None:  # noqa: E501
            raise ValueError("Invalid value for `reward`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                reward is not None and reward > 1000000):  # noqa: E501
            raise ValueError("Invalid value for `reward`, must be a value less than or equal to `1000000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                reward is not None and reward < 0):  # noqa: E501
            raise ValueError("Invalid value for `reward`, must be a value greater than or equal to `0`")  # noqa: E501

        self._reward = reward

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Order):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Order):
            return True

        return self.to_dict() != other.to_dict()
